/*
 * Created on Mar 12, 2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package DataProcess;
import java.util.*;
import java.io.*;
import java.text.*;
import DataProcess.TimeSeries;

/**
 * @author Test Mule
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public class DataSet {

	private Vector mDates;
	private Vector mAttributeVecs;
	
	
	public Date GetDateByIntervalIndex(int index)
	{
		Date ret = null;
		try{
			ret = (Date)(mDates.elementAt(index));
		}
		catch(Exception e){
			System.out.println("GetDateByIntervalIndex:: bad interval index "+index);
		}
		return ret;
	}
	
	public TimeSeries GetSeriesByIndex(int index)
	{
		TimeSeries ret = null;
		
		try{
			ret = (TimeSeries)(mAttributeVecs.get(index));
		}
		catch(ArrayIndexOutOfBoundsException e){
			System.out.println("GetSeriesByIndex::Invalid Array index ");
		}	
		return ret;
	}
	
	public int GetSeriesIndexByCode(String inCode)
	{
		int index = -1;
		for (int i=0;i<mAttributeVecs.size();i++){
			TimeSeries ts = (TimeSeries)(mAttributeVecs.get(i));
			String name = ts.GetName(); 
			if (name.equals(inCode)){
				index = i;
				break;
			}
		}		

		return index;
	}

	public int GetNumIntervals()
	{
		return mDates.size();
	}

	public boolean ReadDataFile(String fileURL)
	{
		mAttributeVecs = new Vector();
		mDates = new Vector();
		
		// open the file for reading
		InputStream   is = null;
		Reader r  = null;
		long lineNum = 0;
		boolean filterFeb29 = true;
		boolean ret = false;
		
		try{

			DateFormat dateFormat = new SimpleDateFormat("mm/dd/yy");       

			FileReader reader = new FileReader(fileURL);
			BufferedReader bReader = new BufferedReader(reader);
			GregorianCalendar cal = new GregorianCalendar();
			SimpleDateFormat auxFormatter = new SimpleDateFormat("mm.dd");

			String line = null;
			while ((line = bReader.readLine()) != null){

				if (lineNum == 0){
					StringTokenizer st = new StringTokenizer(line, ",");
					 for (int j = 0;  st.hasMoreTokens();  j++) {
							String columnHeader = st.nextToken().trim();
							if (j > 0){
								TimeSeries newTS = new TimeSeries(this);
								newTS.SetName(columnHeader);
								mAttributeVecs.addElement(newTS);
							}
					 }
				}
				else{
					StringTokenizer st = new StringTokenizer(line, ",");
					boolean lineScanned = false;
					 for (int j = 0;  st.hasMoreTokens() && !lineScanned;  j++) {
							String valueStr = st.nextToken().trim();
					 		
					 		if (j==0){

					 			// parse the date

								try{
									Date date = dateFormat.parse(valueStr);         
									
									// filter out February 29th
									if (filterFeb29){
										String temp = auxFormatter.format(date);
										
										if (temp.equals("02.29")){
											lineScanned = true;
											continue;
										}
									}
									
									mDates.add(date);
								}
								catch(java.text.ParseException e)
								{
									System.out.println("Bad Date Format");

									// do something here	
								}
					 		}
					 		
					 		if (j>0){
								double val = 0;

					 			try{
									val = Double.parseDouble(valueStr);
					 			}
								catch(Exception e){
									val = 0;								
								}
								
								if (val < 0)
									val = 0;
								
								TimeSeries ts = (TimeSeries)(mAttributeVecs.elementAt(j-1));
								ts.AppendValue(val);
					 		}
					 }
				}
				lineNum++;
			}
			
			ret = true;
		}  
		catch (IOException e) 
		 {
			 System.err.println("File not found: " + e);
			 ret = false;
		 }
	
		System.out.println("Date vec: "+mDates.size());

		TimeSeries ts = (TimeSeries)(mAttributeVecs.elementAt(0));
		System.out.println("TimeSeries: "+ts.size());
		
		 
		 /*
		  * Dump series
		  */
		  /*
		 for (int i=0;i<mAttributeVecs.size();i++)
		 {
			TimeSeries ts = (TimeSeries)(mAttributeVecs.elementAt(i));
			ts.Dump();
		 }
		 */
		 		 
		 return ret; 
	}
}
