/*
 * Created on Mar 12, 2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package DataProcess;

import java.util.*;
import DataProcess.DataSet;
/**
 * @author Lior Berry
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public class TimeSeries {
	
	private ArrayList 	mValues;
	private String 		mName;
	private DataSet 	mDataSet;
	
	private double mMin = -1;
	private double mMax = -1;
	
	public TimeSeries(DataSet inDataSet)
	{
		mValues = new ArrayList();
		mDataSet = inDataSet;
	}
	
	public void SetName(String name)
	{
		mName = name;
	}

	public String GetName()
	{
		return mName;
	}
	
	public void AppendValue(double value)
	{
		if (mValues.size() == 0){
			mMin = value;
			mMax = value;	
		}
		
		if (value < mMin)
			mMin = value;

		if (value > mMax)
			mMax = value;

		mValues.add(new Double(value));			
	}
	
	public double GetValueByIndex(int index)
	{
		Double val = (Double)mValues.get(index);
		return val.doubleValue();
	}
	
	public void Dump()
	{
		System.out.println("Name= "+mName);
		
		for (int i=0; i<mValues.size(); i++) {

			Double s = (Double) mValues.get(i);
			System.out.println(s);

		}
	}
	
	public ArrayList ComputeBins(long binSize)
	{
		ArrayList ret = new ArrayList();
		
		double sum 				= 0.0;
		double sumOfSquares 	= 0.0;
		
		double max = -1.0;
		double min = -1.0;
		
		double binMax = -1.0;
		double binMin = -1.0;
		
		int i;
		int numDays = 0;
		
		int startBinIntervalIndex = 0;
		
		for (i=0; i< mValues.size(); i++) {
			
			if (i>0 && i % binSize == 0){		
				sum /= numDays;
				sumOfSquares /= numDays;
				sumOfSquares -= sum*sum;
				
				if (min < 0.0 || sum < min)
					min = sum;
				if (max < 0.0 || sum > max)
					max = sum;

				sumOfSquares = Math.sqrt(sumOfSquares);
				
				BinData binData= new BinData(sum,0.0,binMax,binMin,sumOfSquares);
				binData.mStartIntervalIndex = startBinIntervalIndex;
				binData.mEndIntervalIndex = i-1;
				startBinIntervalIndex = i;
				ret.add(binData);

				sumOfSquares = 0.0;
				sum = 0.0;

				binMax = -1.0;
				binMin = -1.0;
				numDays = 0;
			}

			double dataEntry = ((Double)mValues.get(i)).doubleValue();

			if (binMin < 0.0 || dataEntry < binMin)
				binMin = dataEntry;
			if (binMax < 0.0 || dataEntry > binMax)
				binMax = dataEntry;

			sum += dataEntry;
			sumOfSquares += dataEntry*dataEntry;
		
			numDays++;
		}

		// add the final value if remaining
		if (numDays != 0){
			
			sum /= numDays;
			sumOfSquares /= numDays;
			sumOfSquares -= sum*sum;
			
			if (min < 0.0 || sum < min)
				min = sum;
			if (max < 0.0 || sum > max)
				max = sum;

			sumOfSquares = Math.sqrt(sumOfSquares);

			BinData binData= new BinData(sum,0.0,binMax,binMin,sumOfSquares);
			binData.mStartIntervalIndex = startBinIntervalIndex;
			binData.mEndIntervalIndex = i-1;
			ret.add(binData);
					
			sum = 0.0;
			sumOfSquares = 0.0;
			numDays = 0;
		}

		// Normalize values
		
		boolean useGlobalMaxMin = true;


		
		if (useGlobalMaxMin){
			max = GetMax();
			min = GetMin();
		}

		for (i=0;i<ret.size();i++){
			BinData temp = (BinData)ret.get(i);
			temp.mNormalizedValue 	= (temp.mBinValue-min)/(max-min);

			// record the raw values
			temp.mRawMaxValue 	= temp.mMaxValue;		
			temp.mRawMinValue 	= temp.mMinValue;			
			temp.mRawStdDev 	= temp.mStdDev; 			
			
			// normalize stddev, binMax, binMin
			temp.mStdDev = temp.mStdDev / (max-min);
			temp.mMaxValue = (temp.mMaxValue-min)/(max-min);
			temp.mMinValue = (temp.mMinValue-min)/(max-min);
		}
		
		return ret;
	}
	
	public double GetMin()
	{
		if (mMin < 0){
				
			for (int i=0;i<mValues.size();i++){
				double val = ((Double)mValues.get(i)).doubleValue();
				if (val < mMin || mMin < 0){
					mMin = val;
				}
			}
				
		}
		return mMin;
	}
	
	public double GetMax()
	{
		if (mMax < 0){
				
			for (int i=0;i<mValues.size();i++){
				double val = ((Double)mValues.get(i)).doubleValue();
				if (val > mMax || mMax < 0){
					mMax = val;
				}
			}
				
		}
		return mMax;	
	}
	public int size()
	{
		return mValues.size();
	}
	
}
