/*
 * Created on Mar 12, 2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */

/**
 * @author Lior Berry
 *
 */

package UI;

import java.awt.*;
//import java.awt.geom.*;
//import java.awt.image.*;
import javax.swing.*;
import java.awt.event.*;
//import java.net.UnknownContentHandler;
import java.util.*;
import java.io.File;
import java.net.URL;
import java.net.MalformedURLException;

import Viz.*;
import DataProcess.DataSet;
import DataProcess.ToolConfiguration;

public class BinXApplication implements ActionListener,ItemListener{

	public JFrame 	m_AppFrame;
	public DataSet	m_DataSet;
	
	JCheckBoxMenuItem mClusterViewMenuItem = null;
	JCheckBoxMenuItem mScatterPlotViewMenuItem = null;
	
	public VizPanelMgr vizMgr = new VizPanelMgr();
	
	class DataFileFilter extends javax.swing.filechooser.FileFilter {
			public boolean accept(File file) {
				String filename = file.getName();
				return filename.endsWith(".csv");
			}
			public String getDescription() {
				return "*.csv";
			}
	}
	
	
	private ToolConfiguration mConfig = null;
	
	ToolConfiguration GetConfig()
	{
		return mConfig;	
	}
	
	private void OpenDataFile()
	{
		
		JFileChooser fc;
		fc = new JFileChooser();
		fc.addChoosableFileFilter(new DataFileFilter());

		int retVal = fc.showOpenDialog(m_AppFrame);

		if(retVal == JFileChooser.APPROVE_OPTION) {
		
			File file = fc.getSelectedFile();
			String filePath = file.getAbsolutePath();
			m_DataSet = new DataSet();
					
			if (!m_DataSet.ReadDataFile(filePath))
			{
				JOptionPane.showMessageDialog(null, "Cannot open data file: "+ file.getAbsolutePath(), "BinX - Error", JOptionPane.ERROR_MESSAGE); 		
			}
			else{
				vizMgr.SetData(m_DataSet);	
			}
		}		
	}

	public JMenuBar createMenuBar(){
		JMenuBar menuBar;
		JMenu menu, submenu;
		JMenuItem menuItem;

		//Create the menu bar.
		menuBar = new JMenuBar();

		//Build the first menu.
		menu = new JMenu("File");
		//menu.setMnemonic(KeyEvent.VK_A);
		menu.getAccessibleContext().setAccessibleDescription(
				"File operations");
		menuBar.add(menu);

		//a group of JMenuItems
		menuItem = new JMenuItem("Open",
								 KeyEvent.VK_O);
		//menuItem.setMnemonic(KeyEvent.VK_T); //used constructor instead
		//menuItem.setAccelerator(KeyStroke.getKeyStroke(
		//		KeyEvent.VK_1, ActionEvent.ALT_MASK));
		menuItem.getAccessibleContext().setAccessibleDescription(
				"Open a data folder");
		menuItem.addActionListener(this);
		menu.add(menuItem);
		
		menuItem = new JMenuItem("Quit",
								 KeyEvent.VK_X);
		//menuItem.setMnemonic(KeyEvent.VK_T); //used constructor instead
		//menuItem.setAccelerator(KeyStroke.getKeyStroke(
		//		KeyEvent.VK_1, ActionEvent.ALT_MASK));
		menuItem.getAccessibleContext().setAccessibleDescription(
				"Exit");
		menuItem.addActionListener(this);
		menu.add(menuItem);


		//Build the selection menu.
		menu = new JMenu("Marking");
		menuBar.add(menu);

/*
		menuItem = new JCheckBoxMenuItem("Marks visible",true );
		menuItem.addActionListener(this);
		menu.add(menuItem);
*/		
		menuItem = new JMenuItem("Mark All",KeyEvent.CTRL_MASK & KeyEvent.VK_A );
		menuItem.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_A, 
													   Event.CTRL_MASK));

		menuItem.addActionListener(this);
		menu.add(menuItem);


		menuItem = new JMenuItem("Clear All",KeyEvent.ALT_MASK & KeyEvent.VK_A);
		menuItem.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_BACK_SPACE, 
													   Event.CTRL_MASK));

		menuItem.addActionListener(this);
		menu.add(menuItem);

		menuItem = new JMenuItem("Reverse Marks",KeyEvent.VK_X);
		menuItem.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_X, 
													   Event.CTRL_MASK | Event.ALT_MASK));

		menuItem.addActionListener(this);
		menu.add(menuItem);

		//Build the configuration menu.
		menu = new JMenu("Views");
		//menu.setMnemonic(KeyEvent.VK_A);
		menu.getAccessibleContext().setAccessibleDescription(
				"Views configuration");
		menuBar.add(menu);

		JMenu scatterPlotMenu = new JMenu("ScatterPlot");

		mScatterPlotViewMenuItem = new JCheckBoxMenuItem("Scatter Plot",false);
		menuItem = mScatterPlotViewMenuItem;
		menuItem.addActionListener(this);
		scatterPlotMenu.add(menuItem);
		
		menuItem = new JCheckBoxMenuItem("Link Marked Data",false);
		menuItem.addActionListener(this);
		scatterPlotMenu.add(menuItem);

		menu.add(scatterPlotMenu);
		
		 
		mClusterViewMenuItem = new JCheckBoxMenuItem("Cluster Viewer",false);;
		menuItem = mClusterViewMenuItem;
		menuItem.addActionListener(this);
		menu.add(menuItem);
		

		/*		
		menuItem = new JCheckBoxMenuItem("Connect lines",true);

		menuItem.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_1, 
													   Event.ALT_MASK));

		menuItem.addActionListener(this);
		menu.add(menuItem);

		menuItem = new JCheckBoxMenuItem("Show Bin Size",false);

		menuItem.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_2, 
													   Event.ALT_MASK));

		menuItem.addActionListener(this);
		menu.add(menuItem);
		*/

		menu = new JMenu("Help");
		menuBar.add(menu);
		menuItem = new JMenuItem("About BinX");
		menuItem.addActionListener(this);
		menu.add(menuItem);

		return menuBar;
	}
	
	public void actionPerformed(ActionEvent e){
		 JMenuItem source = (JMenuItem)(e.getSource());
		 System.out.println("Action Performed: "+source.getText());
		 
		 if (source.getText() == "Open"){
			OpenDataFile();
		 }
		else if (source.getText() == "Quit"){
			System.exit(0);
		}
		else if (source.getText() == "Connect lines"){
				JCheckBoxMenuItem cbItem = (JCheckBoxMenuItem)(source);
				//System.out.println(cbItem.getState());	
				vizMgr.ConnectLinesChanged(cbItem.getState());
		}
		else if (source.getText() == "Show Bin Size"){
				JCheckBoxMenuItem cbItem = (JCheckBoxMenuItem)(source);
				//System.out.println(cbItem.getState());	
				vizMgr.ShowBinSize(cbItem.getState());
		}
		else if (source.getText() == "Mark All"){
			vizMgr.MarkAll();
		}
		else if (source.getText() == "Clear All"){
			vizMgr.ClearAllMarks();
		}
		else if (source.getText() == "Reverse Marks"){
			vizMgr.ReverseMarks();
		}
		else if (source.getText() == "About BinX"){
			JOptionPane.showMessageDialog(null, "BinX - CPSC533\nhttp://www.cs.ubc.ca/~berry", "About BinX", JOptionPane.INFORMATION_MESSAGE); 		
		}
		else if (source.getText() == "Scatter Plot"){
			JCheckBoxMenuItem cbItem = (JCheckBoxMenuItem)(source);
			vizMgr.SetShowScatterPlot(cbItem.getState());
		}
		else if (source.getText() == "Link Marked Data"){
			JCheckBoxMenuItem cbItem = (JCheckBoxMenuItem)(source);
			vizMgr.SetScatterPlotUseMarkedData(cbItem.getState());
		}
		else if (source.getText() == "Cluster Viewer"){
			JCheckBoxMenuItem cbItem = (JCheckBoxMenuItem)(source);
			vizMgr.SetShowClusterViewer(cbItem.getState());
		}
	 }

	 public void itemStateChanged(ItemEvent e) {
		 
		 JMenuItem source = (JMenuItem)(e.getSource());
		 System.out.println("Item state Changed: "+source.getText());
	 }	

	/**
	 * Create the GUI and show it.  For thread safety,
	 * this method should be invoked from the
	 * event-dispatching thread.
	 */
	private static void createAndShowGUI() {
		//Make sure we have nice window decorations.
		//JFrame.setDefaultLookAndFeelDecorated(true);

		ToolConfiguration toolConf = new ToolConfiguration();
		toolConf.ReadFromFile();
 
		//Create and set up the window.
		JFrame frame = new JFrame("BinX - Alpha 1.5");
		frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);

		// create and setup a dataset
		//DataSet currencyDataSet = new DataSet();
		DataSet currencyDataSet = null;
		
		//Create and set up the content pane.
		BinXApplication appCore = new BinXApplication();
		frame.setJMenuBar(appCore.createMenuBar());
		appCore.m_AppFrame = frame;

		//Container content = frame.getContentPane();
		//content.setLayout(new FlowLayout()); 
		UIControls uiControls = new UIControls();
		frame.getContentPane().setLayout(null);
		GridBagConstraints c = new GridBagConstraints();
		String vizType = toolConf.getProperty("Viz");
		
		if (vizType == null || vizType.compareTo("1") == 0){

			appCore.vizMgr.AddPanel(1);
			appCore.vizMgr.AddPanel(1);
			appCore.vizMgr.AttachToUI(frame, currencyDataSet,uiControls);

			appCore.vizMgr.GetPanel(0).SetActive(true);
			
			appCore.vizMgr.GetPanel(0).setSize(new Dimension(800, 250));
			appCore.vizMgr.GetPanel(0).setLocation(0,30);

			frame.getContentPane().add(appCore.vizMgr.GetPanel(0));

			appCore.vizMgr.GetPanel(1).setSize(new Dimension(800, 250));
			appCore.vizMgr.GetPanel(1).setLocation(0,282);
			frame.getContentPane().add(appCore.vizMgr.GetPanel(1));
		}
		else
		{
			System.out.println("Unsupported viz type");
			/*
			VizPanel binPanel = new BinDrawSpiral();
			appCore.m_BinDrawArray.add(binPanel);
			binPanel.Init(currencyDataSet,uiControls);
			binPanel.setPreferredSize(new Dimension(800, 550));
			frame.getContentPane().add(binPanel,BorderLayout.WEST);
			*/
		}

		uiControls.SetVizPanel(appCore.vizMgr);
		uiControls.setPreferredSize(new Dimension(200, 300));
		uiControls.CreateGUI();

		uiControls.setSize(200,290);
		uiControls.setLocation(802,30);
		frame.getContentPane().add(uiControls);
		
		ScatterPlotPanel spPanel = new ScatterPlotPanel();
		spPanel.setSize(190,190);
		spPanel.setLocation(802,320);
		spPanel.Init();
		spPanel.AttachDataSet(currencyDataSet,false);
		//frame.getContentPane().add(spPanel);
		appCore.vizMgr.SetScatterPlotPanel(spPanel,appCore.mScatterPlotViewMenuItem);
		//spPanel.hide();

		ClusterVizPanel cvPanel = new ClusterVizPanel();
		/*
		cvPanel.setSize(800,120);
		cvPanel.setLocation(0,540);
		*/
		cvPanel.Init();
		//frame.getContentPane().add(cvPanel);
		appCore.vizMgr.SetClusterVizPanel(cvPanel,appCore.mClusterViewMenuItem);
		//cvPanel.hide();
		
		JToolBar tbar = uiControls.GetToolBar();
		
		tbar.setLocation(0,0);
		tbar.setSize(600,30);
		frame.getContentPane().add(tbar);
		//Display the window.
		frame.setSize(950, 600);
		//frame.pack();
		
		
		/*
		String dataFile = toolConf.GetDataFile();
		System.out.println("reading... "+dataFile);
		
		if (!currencyDataSet.ReadDataFile(toolConf.GetDataFile()))
		{
			JOptionPane.showMessageDialog(null, "Cannot open data file: "+ toolConf.GetDataFile(), "BinX - Error", JOptionPane.ERROR_MESSAGE); 		
		}
		
		*/

		appCore.vizMgr.Init();
		appCore.vizMgr.GetPanel(0).requestFocus();

		frame.setVisible(true);
	}
	
	public static void main(String[] args) {
		//Schedule a job for the event-dispatching thread:
		//creating and showing this application's GUI.
		
		javax.swing.SwingUtilities.invokeLater(new Runnable() {
			public void run() {
				createAndShowGUI();
			}
		});
	}	
	
	/*

	public static void main(String[] args) {
	
	BinDraw binPanel = new BinDraw();
	binPanel.Init();
	
	binPanel.setPreferredSize(new Dimension(800, 600));
	JFrame frame = new JFrame("BinX");

//	Create the menu bar
	 JMenuBar menuBar = new JMenuBar();
    
	 // Create a menu
	 JMenu menu = new JMenu("File");
	 menuBar.add(menu);
    
	 // Create a menu item
	 JMenuItem item = new JMenuItem("Open");
	 //item.addActionListener(actionListener);
	 menu.add(item);
	 
	 JMenuItem quit = new JMenuItem("Quit");
	 quit.addActionListener(new ActionListener(){
		 public void actionPerformed(ActionEvent e)
		 {
			 System.exit(0);
		 }
		 });
	menu.add(quit); 	 
	 open.addActionListener(new ActionListener(){
	 public void actionPerformed(ActionEvent e){
		 JFileChooser choix = new JFileChooser();
		 choix.setFileSelectionMode(JFileChooser.FILES_AND_DIRECTORIES);
		 //choix.setFileFilter();
		 int returnVal = choix.showOpenDialog(open);
		 if(returnVal == JFileChooser.APPROVE_OPTION);
		 String fileName = choix.getSelectedFile().toString();

		 format = fichier.substring(fichier.length()-3);
		 name = choix.getName(choix.getSelectedFile());

		 try {
		 if(format.equals("ppm")) {
			 ImageData id = new ImageData(fichier);
			 yop = id.draw();
			 w = yop.getWidth();
			 h = yop.getHeight();
			 imageCanvas.set(yop,w,h,id.draw());
		 }
		 else {
			 yop = ImageIO.read(new File(fichier));
			 w = yop.getWidth();
			 h = yop.getHeight();
			 imageCanvas.set(yop,w,h,ImageIO.read(new File(fichier)));
		 }

		 pack();
		 imageCanvas.repaint();
		 set(name+"  |  R =      G =      B =    |  Y =      U =      V =    |");

		 }
		 catch(Exception ex) {
		 System.out.println(ex.getMessage());
		 }

	 	 }
	 });	
	 
	 
	 // Install the menu bar in the frame
	 frame.setJMenuBar(menuBar);

	frame.setDefaultCloseOperation(JFrame.DISPOSE_ON_CLOSE);
	frame.getContentPane().add(binPanel);
	frame.pack();
	frame.show();
	
	binPanel.requestFocus();
	}
*/
}
