/*
 * Created on Mar 12, 2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */

/**
 * @author Lior Berry
 *
 */

package Viz;
import java.awt.*;
//import java.awt.geom.*;
//import java.awt.image.*;
import javax.swing.*;
import java.awt.event.*;
import java.awt.image.BufferedImage;
import java.util.*;
import javax.swing.border. BevelBorder; 
import javax.swing.border. Border; 
import javax.swing.border. EtchedBorder; 
import javax.swing. BorderFactory;

import Viz.*;

import DataProcess.*;
import Utils.ClusterAlgo;

public class BinDrawSpiral extends VizPanel implements KeyListener{
	
	
	private double spiralDiameter = 20.0;
	private double barHeight = 15.0;
	private int numDaysInBin = 1;
	
	// visualization controls
	private boolean showSecondSeries = false;
	private boolean showMonthTicks = true;
	private boolean showBinSize = false;
	
	private BufferedImage bimg;

	public BinDrawSpiral() 
	{ 
		this.addKeyListener( this );
	}
	
	protected void HandleMousePressed(MouseEvent e)
	{
	}
	protected void HandleMouseMoved(MouseEvent e)
	{
	}
	
	protected void HandleMouseDragged(MouseEvent e)
	{
	}
	
	
	private Graphics2D createGraphics2D(int w, int h) {
		
		Graphics2D g2 = null;
		if (bimg == null || bimg.getWidth() != w || bimg.getHeight() != h) {
			bimg = (BufferedImage) createImage(w, h);
		} 
		g2 = bimg.createGraphics();
		g2.setBackground(Color.white);
		g2.clearRect(0, 0, w, h);
		/*
		g2.setRenderingHint(RenderingHints.KEY_ANTIALIASING,
							RenderingHints.VALUE_ANTIALIAS_ON);
		*/
		return g2;
	}	

	public void paintComponent(Graphics gfx) {
		
		super.paintComponent(gfx);
		Graphics2D g = (Graphics2D) gfx;
		
		Dimension d = getSize();
		Graphics2D g2 = createGraphics2D(d.width, d.height);
		
		g2.setRenderingHint(RenderingHints.KEY_ANTIALIASING,
				   RenderingHints.VALUE_ANTIALIAS_ON);
		
		int x,y;
		int oldX,oldY;
	
		int x2,y2;
		int oldX2, oldY2;
	
		int i;
		int cx = d.width / 2;
		int cy = d.height / 2;
		
		int seriesIndex1 = mDataSet.GetSeriesIndexByCode("CAD");
		int seriesIndex2 = mDataSet.GetSeriesIndexByCode("JPY");
		
		boolean drawTicks = false;
		
		ArrayList binValues1 = (mDataSet.GetSeriesByIndex(seriesIndex1)).ComputeBins(numDaysInBin);
		ArrayList binValues2 = null;
		if (showSecondSeries && seriesIndex2 >= 0){
			binValues2 = (mDataSet.GetSeriesByIndex(seriesIndex2)).ComputeBins(numDaysInBin);
		}
		
	//	spiralDiameter = (30.0 / (double)numDaysInBin);
		spiralDiameter = 25.0 - 0.3*numDaysInBin;
	
		int binSize = numDaysInBin;
		int binCounter = 0;
		
		double c = spiralDiameter;
	
	//		g2.setStroke(new BasicStroke(3)); 
	
		double t=1.0;
		double lineGap = barHeight+5.0;
		double radius = spiralDiameter * 10.0;
		
		oldX = (int)(cx + (radius- lineGap * (1.0-t)) * Math.cos(t*2.0*Math.PI));
		oldY = (int)(cy + (radius- lineGap * (1.0-t)) * Math.sin(t*2.0*Math.PI));
		oldX2 = cx;
		oldY2 = cy;
	
	//	System.out.println(numDaysInBin);
		int generalCounter = 0;
		int numLoops = 5;
		int entryIndex=0;

		// draw spokes 
		if (showMonthTicks){
			int monthArray[]={31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31};
			int dayCounter = 0;
			for (i=0;i<12;i++){
				double temp = (double)dayCounter/365.0;
				double rad = radius + lineGap;
				int tempX1 = (int)(cx + (rad * Math.cos(temp*2.0*Math.PI)));
				int tempY1 = (int)(cy + (rad * Math.sin(temp*2.0*Math.PI)));
				
				rad = radius - (numLoops+1)*lineGap;
				
				int tempX2 = (int)(cx + (rad * Math.cos(temp*2.0*Math.PI)));
				int tempY2 = (int)(cy + (rad * Math.sin(temp*2.0*Math.PI)));
	
				g2.setColor(Color.cyan);
				g2.drawLine(tempX2,tempY2,tempX1,tempY1);
				dayCounter += monthArray[i];
			}
		}
		
		for (int k=0;k<numLoops;k++){
			
			binCounter = 0;
			generalCounter = 0;
			t = 1.0;
			
			for (int l =0 ; l < 365 ;l++){
				
				x = (int)(cx + (radius-k*lineGap- lineGap * (1.0-t)) * Math.cos(t*2.0*Math.PI));
				y = (int)(cy + (radius-k*lineGap- lineGap * (1.0-t)) * Math.sin(t*2.0*Math.PI));
				
				//x = (int)(cy + c * t * Math.cos(t*2.0*Math.PI));
				//y = (int)(cy + c * t * Math.sin(t*2.0*Math.PI));
		
				//double rad = /*Math.random()**/15.0;le 
			
				g2.setColor(Color.cyan);
				g2.drawLine(oldX,oldY,x,y);
				
				if (binCounter == 0)
				{
					if (false && generalCounter % 10 == 0){
						g2.setColor(Color.black);
					}
					else{
						g2.setColor(Color.blue);
					}
					Stroke temp = g2.getStroke();
					
					float strokeSize = 1.0f;

					if (binSize > 5 && false){
						strokeSize = 5.0f;
					}

					g2.setStroke(new BasicStroke(strokeSize));

					
					double rad = 0.0;
					
					if (entryIndex < binValues1.size()){
						rad = ((BinData)binValues1.get(entryIndex)).mNormalizedValue;
					}
					
					double usedBarHeight = barHeight;
					if (showSecondSeries){
						usedBarHeight = barHeight/2;						
					}
					rad *= usedBarHeight;
					x2 = (int)(x + rad * Math.cos(t*2.0*Math.PI));
					y2 = (int)(y + rad * Math.sin(t*2.0*Math.PI));
					g2.drawLine(x,y,x2,y2);

					if (showSecondSeries && seriesIndex2 >= 0){

						rad = 0.0;
						if (entryIndex < binValues2.size()){
							rad = ((BinData)binValues1.get(entryIndex)).mNormalizedValue;
						}

						rad *= usedBarHeight;
					
						x2 = (int)(x + (usedBarHeight+rad) * Math.cos(t*2.0*Math.PI));
						y2 = (int)(y + (usedBarHeight+rad) * Math.sin(t*2.0*Math.PI));
						int x3 = (int)(x + usedBarHeight * Math.cos(t*2.0*Math.PI));
						int y3 = (int)(y + usedBarHeight * Math.sin(t*2.0*Math.PI));
						
						g2.setColor(Color.red);
	
						g2.drawLine(x3,y3,x2,y2);
					}

					g2.setStroke(temp);
					
					
					entryIndex++;		
					generalCounter++;
				}
				else{
					x2 = (int)(x + 2 * Math.cos(t*2.0*Math.PI));
					y2 = (int)(y + 2 * Math.sin(t*2.0*Math.PI));
					
					if (drawTicks){
						g2.setColor(Color.gray);
						g2.drawLine(x,y,x2,y2);
					}
				}
		
				binCounter++;
				binCounter = binCounter % (binSize);
		
				oldX = x;
				oldY = y;
		
				oldX2 = x2;
				oldY2 = y2;
			
				t -= 1.0/365.0;
			}
		}
		
		if (showBinSize){
			g2.setColor(Color.gray);
			g2.drawString(Integer.toString(numDaysInBin), 5, d.height-5);
		}
	
		g2.dispose();
		g.drawImage(bimg, 0, 0, this);
	}
	
	public void keyPressed( KeyEvent e ) 
	{
		int key = e.getKeyCode();
		boolean consumed = false;
		
		if (key == KeyEvent.VK_UP){
			if (numDaysInBin >= 2.0){
			
				numDaysInBin -= 1.0;	
				consumed = true;
				repaint();
			}
		}
		else if (key == KeyEvent.VK_DOWN){
			numDaysInBin += 1.0;
			consumed = true;	
			repaint();
		}
		if (key == KeyEvent.VK_LEFT){
			if (barHeight >= 5.0){
				barHeight -= 1.0;	
				consumed = true;
				repaint();
			}
		}
		else if (key == KeyEvent.VK_RIGHT){
			barHeight += 1.0;	
			consumed = true;	
			repaint();
		}
		else if (key == KeyEvent.VK_1){
			showMonthTicks = !showMonthTicks;
			consumed = true;	
			repaint();
		}
		
		else if (key == KeyEvent.VK_2){
			showSecondSeries = !showSecondSeries;
			consumed = true;	
			repaint();
		}
		else if (key == KeyEvent.VK_3){
			showBinSize = !showBinSize;
			consumed = true;	
			repaint();
		}
		
		if (consumed)
			e.consume();
	
	}
	
	public void keyReleased( KeyEvent e ) {}
	public void keyTyped( KeyEvent e ) {}
	
	public  void CurrencySelectionChanged(int inSeries,String inCurrency)
	{
	}
	public  void ShowSecondCurrencyChanged(boolean newVal)
	{
	}

	public  void OverlaySecondCurrencyChanged(boolean newVal)
	{
	}

	public  void DisplayStdDevChanged(boolean newVal)
	{
	}

	public  void DisplayMinMaxChanged(boolean newVal)
	{
	}
	
	public void Init()
	{
	}

	public void ShowMarksChanged(boolean newMode)
	{
		
	}
	public  void MarkAll()
	{
	}
	
	public  void ClearAllMarks()
	{
		
		
	}
	
	public  void ReverseMarks()
	{
		
	}
	
	public void ConnectLinesChanged(boolean newVal)
	{
		
	}
	
	public void ShowBinSize(boolean newVal)
	{
		
	}
	
	public  Color GetColorForSeries(int seriesIndex)
	{
		return null;
	}
	public  void SetColorForSeries(int seriesIndex,Color inColor)
	{
		
	}
	
	public  void DoRepaint(boolean doNotify)
	{
	}
	
	protected void HandleMouseReleased(MouseEvent e)
	{
		
	}

	public int GetCurrencySeriesIndex(int currencyIndex)
	{
		// Convert from the currency ordinal index (0,1) 
		// to the actual index in the data set
		
		return 0;
	}

	public ArrayList GetBinValues(int currencyIndex,boolean onlySelection)
	{
		ArrayList ret = null;
		return ret;		
	}	
	
	public ClusterAlgo GetClusterUtils()
	{
		return null;
	}
	
}
