/*
 * Created on Mar 14, 2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package Viz;


/**
 * @author Test Mule
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */

import java.awt.*;
import javax.swing.*;
import java.awt.event.*;
import javax.swing.border. BevelBorder; 
import javax.swing.border. Border; 
import javax.swing.border. EtchedBorder; 
import javax.swing. BorderFactory;
import javax.swing.JToolTip;
import java.util.*;


import DataProcess.DataSet;
import DataProcess.ToolConfiguration;
import UI.UIControls;
import UI.JMultiLineToolTip;
import Utils.*;

public abstract class VizPanel extends JPanel implements MouseListener,MouseMotionListener,VizPanelControl {

	protected JFrame mOwnerFrame			= null;

	protected DataSet mDataSet 					= null;
	protected ToolConfiguration mConfig 		= null;
	protected UIControls mUIControls 			= null;
	protected boolean mIsActive					= false; 
	
	protected VizPanelMgr mVizPanelMgr 			= null;
	
	protected Rectangle mDisplayRegion;
	
	protected abstract void HandleMousePressed(MouseEvent e);
	protected abstract void HandleMouseMoved(MouseEvent e);
	protected abstract void HandleMouseDragged(MouseEvent e);
	protected abstract void HandleMouseReleased(MouseEvent e);
	
	protected boolean mIntervalSelectionVec[];

		
	public abstract ArrayList GetBinValues(int currencyIndex,boolean onlySelection);
	public abstract int GetCurrencySeriesIndex(int currencyIndex);
	public abstract ClusterAlgo GetClusterUtils();
	
	static public final int NAV_MODE 	= 0;
	static public final int MARK_MODE = 1;
	
	protected int 	mMode = NAV_MODE;

	public void SetData(DataSet inDataSet)
	{
		mDataSet = inDataSet;
		ResetIntervalSelectionVec();
		DoRepaint(false);
	}

	public void AttachToUI(JFrame ownerFrame,
					DataSet inDataSet,
					 UIControls inCtrls)
	{
		mOwnerFrame		= ownerFrame;
		mDataSet 		= inDataSet;
		mUIControls		= inCtrls;
		Border b2 = BorderFactory.createLineBorder  ( Color.black  ); 	
		this.setBorder(b2);
		
		addMouseListener( this);
		addMouseMotionListener(this);

		// register for tooltips		
		ToolTipManager.sharedInstance().registerComponent(this);
	}
	
	public void RegisterVizMgr(VizPanelMgr inMgr)
	{
		mVizPanelMgr = inMgr;
	}
	
	public void mousePressed(MouseEvent e) {
		//saySomething("Mouse pressed (# of clicks: "
		//			 + e.getClickCount() + ")", e);

		requestFocus();
		mVizPanelMgr.RequestActivePanel(this);
		HandleMousePressed(e);
	 }
	 
	public void mouseMoved(MouseEvent e) {
		//System.out.println("Mouse moved");
		HandleMouseMoved(e);
	}
	
	public void mouseDragged(MouseEvent e) {
//		   saySomething("Mouse dragged", e);
			HandleMouseDragged(e);
	}
	

	 public void mouseReleased(MouseEvent e) {
		//saySomething("Mouse released (# of clicks: "
		//			 + e.getClickCount() + ")", e);
		//System.out.println("Mouse Released");
		HandleMouseReleased(e);
	 }

	 public void mouseEntered(MouseEvent e) {
		//saySomething("Mouse entered", e);
		requestFocus();
	 }

	 public void mouseExited(MouseEvent e) {
		//saySomething("Mouse exited", e);
	 }

	 public void mouseClicked(MouseEvent e) {
		//saySomething("Mouse clicked (# of clicks: "
		//			 + e.getClickCount() + ")", e);
		//System.out.println("Mouse Clicked");
	 }
	 
	 public void SetActive(boolean active)
	 {
	 	boolean needRefresh = (mIsActive != active);
	 	mIsActive = active;
	 }
	 
	 public boolean GetIsActive()
	 {
	 	return mIsActive;
	 }
	
	public JToolTip createToolTip()
	{
			JToolTip ret = null;
			ret =  new JMultiLineToolTip();
			return ret;
	}	

	public int GetMode()
	{
		return mMode;
	}

	public void SetMode(int newMode)
	{
		mMode = newMode;
	}
	
	public void SetIsLinked(boolean inLinkState)
	{
		// notify all panels
	}
	
	public void AttachIntervalSelectionVec(VizPanel other)
	{
		mIntervalSelectionVec = other.mIntervalSelectionVec;
	}
	
	public void ResetIntervalSelectionVec()
	{
		if (mDataSet != null){
			mIntervalSelectionVec = new boolean[mDataSet.GetNumIntervals()];
		}
	}

}
