/*
 * Created on Apr 14, 2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package Viz;

import java.util.*;
import java.awt.Color;
import javax.swing.*;
import java.awt.Container;


import UI.UIControls;
import DataProcess.DataSet;
import DataProcess.ToolConfiguration; 

/**
 * @author Lior Berry
 * UBC
*/
public class VizPanelMgr implements VizPanelControl,VizPanelListener{

	protected Vector mVizPanelVec = new Vector();
	protected ScatterPlotPanel mScatterPlot= null;
	protected ClusterVizPanel mClusterViz = null;

	protected boolean 	mLinkedPanels 		= false;
	protected int		mActivePanelIndex 	= -1;
	
	protected boolean 	mShowScatterPlot 	= false;
	protected boolean 	mUseMarkedData 		= false;
	protected boolean 	mShowClusterViewer	= false;
	
	protected JCheckBoxMenuItem mClusterVizMenuItem = null;
	protected JCheckBoxMenuItem mScatterPlotVizMenuItem = null;
	
	JFrame mOwnerFrame = null;

	public void SetData(DataSet inDataSet)
	{
		for (int i=0;i<GetNumPanels();i++){
			GetPanel(i).SetData(inDataSet);
		}
		
		mScatterPlot.AttachDataSet(inDataSet,true);
	}

	public void AddPanel(int vizType)
	{
		VizPanel newPanel = null;
		
		if (vizType == 1){
			newPanel = new BinDrawTrapez();
		}

		newPanel.RegisterVizMgr(this);
		mVizPanelVec.add(newPanel);
		
		if (mVizPanelVec.size() == 1){
			RequestActivePanel(newPanel);			
		}
	}
	
	public void SetScatterPlotPanel(ScatterPlotPanel panel,JCheckBoxMenuItem panelVizMenuItem)
	{
		mScatterPlot = panel;
		mScatterPlotVizMenuItem = panelVizMenuItem;
		mScatterPlot.RegisterWithVizPanelMgr(this);
	}
	
	public void SetClusterVizPanel(ClusterVizPanel panel,JCheckBoxMenuItem panelVizMenuItem)
	{
		mClusterViz = panel;
		mClusterVizMenuItem = panelVizMenuItem;
		mClusterViz.RegisterWithVizPanelMgr(this);
	}
	
	public VizPanel GetPanel(int index)
	{
		return (VizPanel)(mVizPanelVec.elementAt(index));
	}
	
	public int GetNumPanels()
	{
		return mVizPanelVec.size();
	}

	public void Init()
	{
		for (int i=0;i<GetNumPanels();i++){
			GetPanel(i).Init();
		}
	}


	public void AttachToUI(JFrame ownerFrame,
					DataSet inDataSet,
					 UIControls inCtrls)
	{
		for (int i=0;i<GetNumPanels();i++){
			GetPanel(i).AttachToUI(ownerFrame,inDataSet,inCtrls);
		}
		mOwnerFrame = ownerFrame;
	}

	public void CurrencySelectionChanged(int inSeries,String inCurrency)
	{
		for (int i=0;i<GetNumPanels();i++){
			GetPanel(i).CurrencySelectionChanged(inSeries,inCurrency);
		}
		
		UpdateScatterPlot();
				
	}
	public void ShowSecondCurrencyChanged(boolean newVal)
	{
		for (int i=0;i<GetNumPanels();i++){
			GetPanel(i).ShowSecondCurrencyChanged(newVal);
		}
	}
	
	public void OverlaySecondCurrencyChanged(boolean newVal)
	{
		for (int i=0;i<GetNumPanels();i++){
			GetPanel(i).OverlaySecondCurrencyChanged(newVal);
		}
	}
	
	public void DisplayStdDevChanged(boolean newVal)
	{
		for (int i=0;i<GetNumPanels();i++){
			GetPanel(i).DisplayStdDevChanged(newVal);
		}
	}
	
	public void DisplayMinMaxChanged(boolean newVal)
	{
		for (int i=0;i<GetNumPanels();i++){
			GetPanel(i).DisplayMinMaxChanged(newVal);
		}
	}
	
	public void ConnectLinesChanged(boolean newVal)
	{
		for (int i=0;i<GetNumPanels();i++){
			GetPanel(i).ConnectLinesChanged(newVal);
		}
	}
	
	public void ShowBinSize(boolean newVal)
	{
		for (int i=0;i<GetNumPanels();i++){
			GetPanel(i).ShowBinSize(newVal);
		}		
	}
	
		
	public void ShowMarksChanged(boolean newMode)
	{
		for (int i=0;i<GetNumPanels();i++){
			GetPanel(i).ShowMarksChanged(newMode);
		}
		
	}
	
	public void MarkAll()
	{
		for (int i=0;i<GetNumPanels();i++){
			GetPanel(i).MarkAll();
		}

		UpdateScatterPlot();

	}
	
	public void ClearAllMarks()
	{
		for (int i=0;i<GetNumPanels();i++){
			GetPanel(i).ClearAllMarks();
		}

		UpdateScatterPlot();
		
	}
	
	public void ReverseMarks()
	{
		if (mLinkedPanels){
			GetPanel(0).ReverseMarks();
			for (int i=1;i<GetNumPanels();i++){
				GetPanel(i).DoRepaint(false);
			}
		}
		else{
			for (int i=0;i<GetNumPanels();i++){
				GetPanel(i).ReverseMarks();
			}
		}
		
		UpdateScatterPlot();

	}

	public Color GetColorForSeries(int seriesIndex)
	{
		Color ret = GetPanel(0).GetColorForSeries(seriesIndex);
		return ret;		
	}
	public void SetColorForSeries(int seriesIndex,Color inColor)
	{
		for (int i=0;i<GetNumPanels();i++){
			GetPanel(i).SetColorForSeries(seriesIndex,inColor);
		}
		
		if (mScatterPlot != null)
		{
			mScatterPlot.SetColorForSeries(seriesIndex,inColor);
			UpdateScatterPlot();
		}
		
	}
	
	public int GetMode()
	{
		int mode;
		mode = GetPanel(0).GetMode();
		return mode;
	}
	
	public void SetMode(int newMode)
	{
		for (int i=0;i<GetNumPanels();i++){
			GetPanel(i).SetMode(newMode);
		}
	}
	
	
	
	public void RequestActivePanel(VizPanel inPanel)
	{
		for (int i=0;i<GetNumPanels();i++){
			VizPanel panel = GetPanel(i);
			if (panel == inPanel){
				panel.SetActive(true);
				mActivePanelIndex = i;
			}
			else{
				panel.SetActive(false);
			}
		}
		UpdateScatterPlot();
		UpdateClusterViz();
	}
	
	public void DeclineActivePanel(VizPanel inPanel)
	{
		for (int i=0;i<GetNumPanels();i++){
			VizPanel panel = GetPanel(i);
			if (panel == inPanel){
				panel.SetActive(false);
			}
			else{
				panel.SetActive(true);
				mActivePanelIndex = i;
			}
		}
		UpdateScatterPlot();
		UpdateClusterViz();		

	}
	
	public void NotifyOnDaysShiftChange(VizPanel inPanel,int newDaysShift)
	{
		if (mLinkedPanels){
			for (int i=0;i<GetNumPanels();i++){
				VizPanel panel = GetPanel(i);
				if (panel != inPanel && panel instanceof BinDrawTrapez){
					BinDrawTrapez binTrap = (BinDrawTrapez)(panel);
					binTrap.ChangeDaysShift(newDaysShift,false);
				}
			}
				
		}
	}
	
	public void NotifyOnBinInfoChange(VizPanel inPanel,int newIntervalInFocus,int focusPeriodLength)
	{
		if (mLinkedPanels){
			for (int i=0;i<GetNumPanels();i++){
				VizPanel panel = GetPanel(i);
				if (panel != inPanel && panel instanceof BinDrawTrapez){
					BinDrawTrapez binTrap = (BinDrawTrapez)(panel);
					binTrap.SyncBinInfoDraw(newIntervalInFocus,true,focusPeriodLength);
				}
			}
		}
	}	
	
	public void DoRepaint(boolean doNotify)
	{
		for (int i=0;i<GetNumPanels();i++){
			GetPanel(i).DoRepaint(doNotify);
		}
		
	}
	
	public void NotifyOnRepaint(VizPanel inPanel)
	{
		if (mLinkedPanels){
			for (int i=0;i<GetNumPanels();i++){
				VizPanel panel = GetPanel(i);
				if (panel != inPanel){
					panel.DoRepaint(false);
				}
			}
		}
		
		UpdateScatterPlot();
	}
	
	public void NotifyOnUpdateBinSize(VizPanel inPane,int newBinSize)
	{
		System.out.println("NotifyOnUpdateBinSize: "+newBinSize);
		UpdateScatterPlot();
	}
	
	public void NotifyOnClusteringStatusChange(VizPanel inPanel)
	{
		UpdateClusterViz();
	}
	
	public void SetIsLinked(boolean inLinkState)
	{
		mLinkedPanels = inLinkState;

		// handle selection vectors		
		if (mLinkedPanels){
			for (int i=1;i<GetNumPanels();i++){
				GetPanel(i).AttachIntervalSelectionVec(GetPanel(0));
			}
		}
		else{
			for (int i=1;i<GetNumPanels();i++){
				GetPanel(i).ResetIntervalSelectionVec();
			}
		}
		
		DoRepaint(false);
	}
	
	protected void UpdateScatterPlot()
	{
		// get active panel
		if (mScatterPlot != null && mShowScatterPlot){
			VizPanel activePanel = GetPanel(mActivePanelIndex);
			
			ArrayList series1 = activePanel.GetBinValues(0,mUseMarkedData);
			ArrayList series2 = activePanel.GetBinValues(1,mUseMarkedData);
			
			mScatterPlot.SetValues(series1,activePanel.GetCurrencySeriesIndex(0),series2,activePanel.GetCurrencySeriesIndex(1));
			mScatterPlot.DoRepaint();
		}
	}
	
	protected void UpdateClusterViz()
	{
		if (mClusterViz != null && mShowClusterViewer){
			VizPanel activePanel = GetPanel(mActivePanelIndex);
			mClusterViz.SetClusterAlgo(activePanel.GetClusterUtils());
			mClusterViz.DoRepaint();
		}
	}
	
	public void SetShowScatterPlot(boolean newValue)
	{
		mShowScatterPlot = newValue;

		// Sync the associated menu item
		mScatterPlotVizMenuItem.setSelected(newValue);

		if (mShowScatterPlot == true){
			JDialog dlg = mScatterPlot.CreateContainerDialog(mOwnerFrame);
			dlg.show();
			mScatterPlot.show();

			UpdateScatterPlot();	
			//Container c = mScatterPlot.getParent();
			//c.repaint();
		}
		else{
			JDialog dlg = mScatterPlot.CreateContainerDialog(mOwnerFrame);
			dlg.hide();
		}

	}
	
	public void SetShowClusterViewer(boolean newValue)
	{
		mShowClusterViewer = newValue;
		
		// Sync the associated menu item
		mClusterVizMenuItem.setSelected(newValue);
		
		if (mShowClusterViewer == true){
			JDialog dlg = mClusterViz.CreateContainerDialog(mOwnerFrame);
			dlg.show();
			UpdateClusterViz();	
			mClusterViz.show();
			//Container c = mScatterPlot.getParent();
			//c.repaint();
		}
		else{
			JDialog dlg = mClusterViz.CreateContainerDialog(mOwnerFrame);
			dlg.hide();
		}
	}
	
	
	public void SetScatterPlotUseMarkedData(boolean newValue)
	{
		mUseMarkedData = newValue;
		UpdateScatterPlot();	
	}
 
}
